import re
import sys
from itertools import count
from string import ascii_lowercase


# convert string to list of alphabet positions
def letter_indexes(text):
    letter_mapping = dict(zip(ascii_lowercase, count(1)))
    indexes = [
        letter_mapping[letter] for letter in text.lower()
        if letter in letter_mapping
    ]

    return indexes


def task1_encrypt(one, two):

    # convert strings to list of alphabet positions
    list1 = letter_indexes(one)
    list2 = letter_indexes(two)
    # iterate until length of key
    if len(list1) >= len(list2):
        for i in range(len(list2)):
            # shift char by amount in key position
            list1[i] += list2[i]
            # if exceeds alphabet length loop back around
            if list1[i] > 26:
                list1[i] -= 26
    # iterate until length of plain text
    else:
        for i in range(len(list1)):
            list1[i] += list2[i]
            if list1[i] > 26:
                list1[i] -= 26

    # convert list of alphabet positions to ascii
    for i in range(len(list1)):
        list1[i] += 96
        list1[i] = chr(list1[i])

    # convert list to string
    str1 = ''.join(list1)
    return str1


def task1_decrypt(one, two):

    list1 = letter_indexes(one)
    list2 = letter_indexes(two)

    # iterate until length of key
    if len(list1) >= len(list2):
        for i in range(len(list2)):
            # shift char by amount in key position
            list1[i] -= list2[i]
            # if exceeds alphabet length loop back around
            if list1[i] <= 0:
                list1[i] += 26
    # iterate until length of plain text
    else:
        for i in range(len(list1)):
            list1[i] -= list2[i]
            if list1[i] <= 0:
                list1[i] += 26

    # convert list of alphabet positions to ascii
    for i in range(len(list1)):
        list1[i] += 96
        list1[i] = chr(list1[i])

    # convert list to string
    str1 = ''.join(list1)
    return str1


print("Please enter a string to encrypt(in all lower case letters): ")
plainText = input()
print("Please enter a key to encrypt the string with(in all letters): ")
key = input()
if len(key) < 1:
    print("Key Length too short")
    sys.exit()

# remove everything thats not a lowercase letter from string
cleanText = re.sub("[^a-z]", "", plainText)
cleanKey = re.sub("[^a-zA-Z]", "", key)

# notify user of cleaned input
print("Plain text that will be encrypted:", cleanText)
print("Key text that will be used to encrypt:", cleanKey)

# run encryption function and output result
cipherText = task1_encrypt(cleanText, cleanKey)
print("Encrypted text: ")
print(cipherText)

# run decryption function and output result
print("Decrypted Text: ")
decrypt = task1_decrypt(cipherText, cleanKey)
print(decrypt)



